/*

	Scan Data.Asm to generate code

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct info
{
char Name[32];
int  Size,Low,High;
unsigned long Default;
char Type;
char Desc[64];
} Items[64];

int ICount = 0;

void Generate(char *s)
{
int i,c;
char *p1;
struct info *pI;
pI = &Items[ICount++];
strncpy(pI->Name,s,14);
pI->Name[14] = '\0';
s = s + 17;
pI->Size = 1;
if (*s == 'w') pI->Size = 2;
if (*s == 'd') pI->Size = 4;
p1 = s = s + 7;
while (*p1 != ' ' && *p1 != 'h') p1++;
pI->Default = 0;
while (*s != ' ' && *s != 'h')
	{
	pI->Default = pI->Default * (*p1 == 'h' ? 16 : 10);
	c = (*s++)-48;
	if (c >= 10) c = c-7;
	pI->Default = pI->Default+c;
	}
while (*s != ';') s++;
s++;
while (*s == ' ') s++;
pI->Type = *s++;
while (*s == ' ') s++;
pI->Low = pI->High = 0;
if (pI->Type == '#')
	{
	pI->Low = atoi(s);
	while (*s != '-') s++;
	s++;
	pI->High = atoi(s);
	while (*s != ' ') s++;
	}
while (*s == ' ') s++;
strcpy(pI->Desc,s);
return;
}

void main(int argc,char *argv[])
{
FILE *f = fopen("data.asm","rb+");
char Line[256];
static char *DataType[] = {"unsigned char","unsigned int","","unsigned long" };
int i,n,On = 0;
if (f == NULL) exit(0);
while (fgets(Line,255,f) != NULL)
	{
	while (*Line != '\0' && Line[strlen(Line)-1] <= ' ')
		Line[strlen(Line)-1] = '\0';
	while (*Line == ' ') strcpy(Line,Line+1);
	if (strnicmp(Line,"userdataend:",12) == 0) On = 0;
	if (On && *Line != '\0')
					Generate(Line);
	if (strnicmp(Line,"userdatastart:",14) == 0) On = 1;
	}
fclose(f);

printf("char *CGetText(int n)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	printf(" case %d:return \"%s\";\n",i,Items[i].Desc);
printf(" }\nreturn \"????\";\n}\n\n");

printf("unsigned long CGetDefault(int n)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	printf(" case %d:return 0x%lxL;\n",i,Items[i].Default);
printf(" }\nreturn 0L;\n}\n\n");

printf("unsigned long CValidate(int n,unsigned long v)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	if (Items[i].Type == '#')
		printf(" case %d:return (v >= %dL && v <= %dL);\n",
				i,Items[i].Low,Items[i].High);
printf(" }\nreturn -1;\n}\n\n");

printf("struct ConfigStruct\n{\n");
for (i = 0;i < ICount;i++)
	{
	printf("%-20s %-20s; /* %s */\n",
			DataType[Items[i].Size-1],Items[i].Name,Items[i].Desc);
	}
printf("} CFG;\n\n");

printf("unsigned long CGet(int n)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	printf(" case %d:return (long)CFG.%s;\n",i,Items[i].Name);
printf(" }\nreturn 0L;\n}\n\n");

printf("unsigned char CGetType(int n)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	printf(" case %d:return '%c';\n",i,Items[i].Type);
printf(" }\nreturn 0L;\n}\n\n");

printf("unsigned void CPut(int n,unsigned long v)\n{\nswitch(n)\n {\n");
for (i = 0;i < ICount;i++)
	printf(" case %d:CFG.%s = (%s)v;return;\n",i,Items[i].Name,DataType[Items[i].Size-1]);
printf(" }\n}\n\n");

n = 0;
printf("int CX(int n)\n{switch(n)\n {\n");
for (i = 0;i < ICount;i++)
	{
	if (*Items[i].Name != '_')
		printf(" case %d:return %d;\n",n++,i);
	}
printf("}\nreturn 0;\n}\n\n");

printf("int CCount(void) { return %d; }\n",n);
printf("int CCountAll(void) { return %d; }\n",ICount);

}
