/************************************************************************/
/*                                                                      */
/*						Instruction Generation							*/
/*                                                                      */
/************************************************************************

Generates : CB xx

*/

#include "cpu.h"

void GroupCB(void)
{
int Op,Reg,Bit;
char Descr[32];

Define(0xCB,0,"ext cb");
LookJump("OPVCB");
EndDefine();

for (Op = 0;Op < 8;Op++)       			/* Do the rot/shift/swap */
	for (Reg = 0;Reg < 8;Reg++)			/* on the various targets */
		{
		sprintf(Descr,"%s %s",GetOpName(Op+8),GetRegName(Reg));
		Define(CB_EXT+Op*8+Reg,(Reg == REG_HL) ? 16 : 8,Descr);
		GetReg(Reg,"al");
		Operation(Op+8); 				/* Do the rotate */
		if (Op != 6)					/* Swap doesn't set Z */
				Operation(O_SETZ);		/* but all the others do */
		PutReg(Reg,"al");
		EndDefine();
		}

for (Bit = 0;Bit < 8;Bit++)				/* the 8 bits */
	for (Reg = 0;Reg < 8;Reg++)			/* the 8 operands */
		{
		sprintf(Descr,"bit %d,%s",Bit,GetRegName(Reg));
		Define(CB_EXT+0x40+Bit*8+Reg,(Reg == REG_HL) ? 16 : 8,Descr);
		if (Reg == REG_HL)
			{
			printf("    mov bx,[word ptr %s]\n",GetZRegName("hl"));
			MemRead("cl");
			}
		else
			GetReg(Reg,"cl");
		printf("    mov al,%d\n",(1 << Bit));
		Operation(O_BIT);
		EndDefine();

		sprintf(Descr,"res %d,%s",Bit,GetRegName(Reg));
		Define(CB_EXT+0x80+Bit*8+Reg,(Reg == REG_HL) ? 16 : 8,Descr);
		if (Reg == REG_HL)
			{
			printf("    mov bx,[word ptr %s]\n",GetZRegName("hl"));
			MemRead("cl");
			printf("    and cl,%d\n",255-(1 << Bit));
			MemWrite("cl");
			}
		else
			printf("    and [%s],%d\n",
					GetZRegName(GetRegName(Reg)),255-(1 << Bit));

		EndDefine();

		sprintf(Descr,"set %d,%s",Bit,GetRegName(Reg));
		Define(CB_EXT+0xC0+Bit*8+Reg,(Reg == REG_HL) ? 16 : 8,Descr);
		if (Reg == REG_HL)
			{
			printf("    mov bx,[word ptr %s]\n",GetZRegName("hl"));
			MemRead("cl");
			printf("    or cl,%d\n",(1 << Bit));
			MemWrite("cl");
			}
		else
			printf("    or [%s],%d\n",
					GetZRegName(GetRegName(Reg)),(1 << Bit));

		EndDefine();
		}
}
